﻿#include "StdAfx.h"
#include "ChatSearchWnd.h"
#include "UIMenu.h"
#include "main_frame.hpp"
#include "NeMessengerDlg.h"
#include "SmsSearchWnd.h"
#include "SMSSendWnd.h"
#include "SMSModel.h"
#include "SMSController.h"

static bool OnLogoButtonEvent(void* event) 
{
	TEventUI *pEvent = (TEventUI*)event;
	static CString strOldImage = _T("");
    if( pEvent->Type == UIEVENT_BUTTONDOWN ) 
	{
		CControlUI* pButton = pEvent->pSender;
		if( pButton != NULL ) 
		{
			CListContainerElementUI* pListElement = (CListContainerElementUI*)(pButton->GetTag());
			if( pListElement != NULL ) 
			{
				COrganizationTreeUI *pThis = (COrganizationTreeUI *)pListElement->GetOwner();				
				CButtonUI* logo_button = static_cast<CButtonUI*>(pThis->paint_manager_.FindSubControlByName(pListElement, kSmsPopupSearchItemLogo));
				if ( logo_button!=NULL)
				{				
					CRect rcItem = pButton->GetPos();
					Node* pNode = (Node*)pListElement->GetTag();
					if (pNode != NULL)
					{
						HWND hwndSms = logo_button->GetManager()->GetPaintWindow();
						RECT rcClient = {0};	
	
						GetWindowRect(hwndSms, &rcClient);			
						RECT rcAround = {rcClient.left + rcItem.left - 5, rcClient.top + rcItem.top, rcClient.left + rcItem.right + 5, rcClient.top + rcItem.bottom};//organization_item.xml


						GET_MESSENGER_DLG()->GetProfileDlgController()->CreateProfileDlg(pNode->data().value.GetData(), rcAround,hwndSms);
					}

					CString strImage = _T("img_main_mouse_move.png");
					logo_button->SetHotImage(strImage);
					logo_button->SetNormalImage(strImage);
				}
				pListElement->DoEvent(*pEvent);
			}
		}
    }
	else if( pEvent->Type == UIEVENT_MOUSEENTER )
	{
		CControlUI* pButton = pEvent->pSender;
		if( pButton != NULL ) 
		{
			CListContainerElementUI* pListElement = (CListContainerElementUI*)(pButton->GetTag());
			if( pListElement != NULL ) 
			{
				COrganizationTreeUI *pThis = (COrganizationTreeUI *)pListElement->GetOwner();
				CButtonUI* logo_button = static_cast<CButtonUI*>(pThis->paint_manager_.FindSubControlByName(pListElement, kSmsPopupSearchItemLogo));
				if ( logo_button!=NULL)
				{
					/*CRect rcpadding(0,0,0,0);
					pButton->SetPadding(rcpadding);*/
					CRect rcItem = pButton->GetPos();
					Node* pNode = (Node*)pListElement->GetTag();
					CString strImage = /*GetAppDUIImgDir() +*/ _T("\\img_main_mouse_move.png");
					strOldImage = logo_button->GetNormalImage();
					logo_button->SetNormalImage(strImage);
					logo_button->SetHotImage(strImage);
				}
				pListElement->DoEvent(*pEvent);
			}
		}
	
	}
	else if( pEvent->Type == UIEVENT_MOUSELEAVE )
	{
		CControlUI* pButton = pEvent->pSender;
        if( pButton != NULL ) 
		{
            CListContainerElementUI* pListElement = (CListContainerElementUI*)(pButton->GetTag());
            if( pListElement != NULL ) 
			{
				COrganizationTreeUI *pThis = (COrganizationTreeUI *)pListElement->GetOwner();
				CButtonUI* logo_button = static_cast<CButtonUI*>(pThis->paint_manager_.FindSubControlByName(pListElement, kSmsPopupSearchItemLogo));
				if ( logo_button!=NULL)
				{
					
					logo_button->SetNormalImage(strOldImage);
					logo_button->SetHotImage(strOldImage);
				}
				pListElement->DoEvent(*pEvent);
			}
        }
	}
    return true;
}





DUI_BEGIN_MESSAGE_MAP(CSmsSearchWnd, WindowImplBase, FALSE)
    DUI_ON_MSGTYPE(DUI_MSGTYPE_WINDOWINIT, _OnNotifyPrepare)
   // DUI_ON_MSGTYPE(DUI_MSGTYPE_ITEMCLICK, _OnNotifyItemClick)
    DUI_ON_CLICK_CTRNAME(kSmsPopupSearchItemAdd, _OnCtrlChatAddBtnClick)
	DUI_ON_MSGTYPE(WM_SYSKEYDOWN, _OnMsgSysKeyDown)
	DUI_ON_MSGTYPE(WM_SIZE, _OnMsgSize)
DUI_END_MESSAGE_MAP()

DUI_BEGIN_CUSTOM_MSG_MAP(CSmsSearchWnd)  
    ON_CUSTOM_MSG(MSG_ACTIVE_PRARENT, _OnMsgActiveParent)
    ON_CUSTOM_MSG(MSG_INACTIVE_HIDE, _OnMsgInactiveHide)
DUI_END_CUSTOM_MSG_MAP()


CSmsSearchWnd::CSmsSearchWnd(CSMSSendWnd *pChatDlg):text_padding_(0,0,0,0)
{
	m_pSmsSendWnd = pChatDlg;
	m_nSmsSearchWndHeight = 148;
	root_node_ = new Node;
	root_node_->data().level_ = -1;
	root_node_->data().child_visible_ = true;
	root_node_->data().has_child_ = true;
	root_node_->data().list_elment_ = NULL;

	level_text_start_pos_ = 0;
	m_rcClient.SetRectEmpty();
}

CSmsSearchWnd::~CSmsSearchWnd()
{
	if (root_node_)
		delete root_node_;

	root_node_ = NULL;
}

LPCTSTR CSmsSearchWnd::GetWindowClassName() const
{
	return _T("SmsSearchWnd");
}

void CSmsSearchWnd::UpdateAddBtnAndTooltip(CString strID,CString strTel)
{

	Node* node = NULL;
	CString strUserID = _T("");
	for (int i = 0; i < root_node_->num_children(); i++)
	{
		node = root_node_->child(i);
		if(node != NULL)
		{
			strUserID = node->data().value;
			if(strUserID == strID)
			{
				
				CButtonUI* btn_add = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(node->data().list_elment_, kSmsPopupSearchItemAdd));
				if (btn_add != NULL)
				{					
					if (!m_pSmsSendWnd->FindTelInSMSWnd((CString)strTel))
					{
						btn_add->SetEnabled(true);
						btn_add->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_15));
					}
					else
					{
						btn_add->SetEnabled(false);
						btn_add->SetToolTip(_T("can't add"));
					}


				}
				break;
			}
		}
	}
}



void CSmsSearchWnd::OnFinalMessage(HWND hWnd)
{
	CListUI* pFriendsList = GetFriendsCtrl();
	if (pFriendsList != NULL)
	{
		if (pFriendsList->GetCount() > 0)
		{
			pFriendsList->RemoveAll();
		}
	}
	WindowImplBase::OnFinalMessage(hWnd);
	if (m_pSmsSendWnd != NULL)
	{
		::SendMessage(m_pSmsSendWnd->GetHWND(), MSG_CLOSE_SMS_SEARCH, 0, 0);
	}
	delete this;	
}

std::vector<CString> CSmsSearchWnd::GetListUserID()
{
	std::vector<CString> vecUserID;
	CListUI* pLeftList = GetFriendsCtrl();
	if (pLeftList != NULL)
	{
		Node* node = NULL;
		for (int i = 0; i < root_node_->num_children(); i++)
		{
			node = root_node_->child(i);
			if(node != NULL)
			{
				vecUserID.push_back(node->data().value.GetData());
			}
		}
	}
	return vecUserID;
}

void CSmsSearchWnd::_OnCtrlChatAddBtnClick(TNotifyUI& msg)
{
    Node* node = (Node*)msg.pSender->GetTag();
	if(!node){
		ASSERT(FALSE);
		return;
	}
    //::PostMessage(m_pSmsSendWnd->GetHWND(), WM_ADD_USER_SMS, (WPARAM)node, 0);

	//NTALKCL-1274

	m_pSmsSendWnd->InitializeMsgPopOnce();
	m_pSmsSendWnd->OnAddUserToSMS(node);
}

void CSmsSearchWnd::_OnMsgSize(TNotifyUI& msg) //(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
   /* if (m_pChatDlg != NULL)
    {
        m_pChatDlg->ReSizeCtrl();
    }
	bHandled = FALSE;*/
  //  return 0;
}

LRESULT CSmsSearchWnd::_OnMsgActiveParent(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	SetFocus(m_hWnd);
    return 0;
}


LRESULT CSmsSearchWnd::OnKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled){

	if ((TCHAR)wParam == VK_ESCAPE)
	{
		if (m_pSmsSendWnd != NULL)
		{
			  m_pSmsSendWnd->CloseSmsSearchWnd(TRUE, TRUE);

		}
		bHandled = TRUE;
	}
	else
	{
		bHandled = FALSE;
	}
	return 0; 

}

LRESULT CSmsSearchWnd::OnMouseWheel(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	LRESULT lRes = 0;
	m_PaintManager.MessageHandler(uMsg, wParam, lParam, lRes);

	return 0;
}


LRESULT CSmsSearchWnd::_OnMsgInactiveHide(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{

    CPoint pt(0, 0);
    GetCursorPos(&pt);
    CRect rcClient(0, 0, 0, 0);
    GetWindowRect(m_hWnd, rcClient);
    CRect rcSearchBtn(3, rcClient.bottom, 25, rcClient.bottom + 30);

    CRect rcProfile(0, 0, 0, 0);
    BOOL bOnProfile = FALSE;
    if (g_pProfileWnd != NULL && IsWindow(g_pProfileWnd->GetHWND()) && g_pProfileWnd->GetParentHwnd() == m_hWnd)
    {
        GetWindowRect(g_pProfileWnd->GetHWND(), rcProfile);
        if (rcProfile.PtInRect(pt))
        {
            bOnProfile = TRUE;
        }
    }
    if (m_pSmsSendWnd != NULL && !rcClient.PtInRect(pt) && !rcSearchBtn.PtInRect(pt) && !bOnProfile)
    {
       // m_pSmsSendWnd->CloseChatSearchWnd(TRUE);
    }
    return 0;
}

void CSmsSearchWnd::_OnMsgSysKeyDown(TNotifyUI& msg) //(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
  //  bHandled = FALSE;
    if (GetKeyState(VK_MENU) < 0 && VK_F4 == msg.wParam)
    {
        if (m_pSmsSendWnd != NULL)
        {
            m_pSmsSendWnd->CloseSmsSearchWnd(TRUE, TRUE);
           // bHandled = TRUE;
        }
    }
   // return 0;
}

int CSmsSearchWnd::GetSearchHeight()
{
	return m_nSmsSearchWndHeight;
}

void CSmsSearchWnd::SetSearchHeight(int nHeight, BOOL bResize)
{
	m_nSmsSearchWndHeight = nHeight;
	if (bResize)
	{
		CRect rcSearch = GetRectInParent();		
		rcSearch.top = rcSearch.bottom - m_nSmsSearchWndHeight;
		SetRectInParent(rcSearch);
	}
}




void CSmsSearchWnd::SetRectInParent(CRect rc)
{
	m_rcClient = rc;
	MoveWindow(GetHWND(), m_rcClient.left, m_rcClient.top, m_rcClient.Width(), m_rcClient.Height(), TRUE);
}

int CSmsSearchWnd::GetChatSearchHeight()
{
	return m_nSmsSearchWndHeight;
}

void CSmsSearchWnd::InitWindow()
{
	MoveWindow(GetHWND(), m_rcClient.left, m_rcClient.top, m_rcClient.Width(), m_rcClient.Height(), TRUE);
}

void CSmsSearchWnd::_OnNotifyPrepare(TNotifyUI& msg)
{
	//UpdateFriendsList();
}

CDuiString CSmsSearchWnd::GetSkinFile()
{
	return _T("SmsSearchWnd.xml");
}

CDuiString CSmsSearchWnd::GetSkinFolder()
{
	return _T("skin\\nTalkRes");
}

LRESULT CSmsSearchWnd::OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	CPoint pt(0, 0);
	GetCursorPos(&pt);
	CRect rcClient(0, 0, 0, 0);
	GetWindowRect(m_hWnd, rcClient);
	CRect rcSearchBtn(rcClient.left + 3, rcClient.bottom, rcClient.left + 25, rcClient.bottom + 30);
	CRect rcProfile(0, 0, 0, 0);
	BOOL bOnProfile = FALSE;
	if (g_pProfileWnd != NULL && IsWindow(g_pProfileWnd->GetHWND()) && g_pProfileWnd->GetParentHwnd() == m_hWnd)
	{
		GetWindowRect(g_pProfileWnd->GetHWND(), rcProfile);
		if (rcProfile.PtInRect(pt))
		{
			bOnProfile = TRUE;
		}
	}
	if (m_pSmsSendWnd != NULL && !rcClient.PtInRect(pt) && !rcSearchBtn.PtInRect(pt) && !bOnProfile)
	{
		m_pSmsSendWnd->CloseSmsSearchWnd(TRUE, TRUE);
	}

	return 0;
}

CListUI* CSmsSearchWnd::GetFriendsCtrl()
{
	CListUI* pFriendsList = static_cast<CListUI*>(m_PaintManager.FindControl(kSmsPopupSearchList));
	return pFriendsList;
}



CLabelUI* CSmsSearchWnd::GetNosearchResultLabel()
{
	return static_cast<CLabelUI*>(m_PaintManager.FindControl(kNosearchResult));
}

LRESULT CSmsSearchWnd::OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	//int ret = __super::OnNcHitTest(uMsg, wParam, lParam, bHandled);
	//if(HTTOP != ret)
	//{
	bHandled = TRUE;
	return HTCLIENT;
	//}
	//return ret;
}


bool CSmsSearchWnd::AddAt(CControlUI* pControl, int iIndex)
{
	if (!pControl)
		return false;

	if (_tcsicmp(pControl->GetClass(), _T("ListContainerElementUI")) != 0)
		return false;

	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kSmsPopupSearchList));
	if (!pList)
	{
		ASSERT(FALSE);
		return false;
	}
	return pList->AddAt(pControl, iIndex);
} 


bool CSmsSearchWnd::RemoveAt(int iIndex)
{
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kSmsPopupSearchList));
	if (!pList)
	{
		ASSERT(FALSE);
		return false;
	}
	CControlUI* pControl = pList->GetItemAt(iIndex);
	if (!pControl)
		return false;

	if (_tcsicmp(pControl->GetClass(), _T("ListContainerElementUI")) != 0)
		return false;


	if (reinterpret_cast<Node*>(static_cast<CListContainerElementUI*>(pControl->GetInterface(_T("ListContainerElement")))->GetTag()) == NULL)
		return pList->RemoveAt(iIndex);
	else
		return RemoveNode(reinterpret_cast<Node*>(static_cast<CListContainerElementUI*>(pControl->GetInterface(_T("ListContainerElement")))->GetTag()));
}

void CSmsSearchWnd::RemoveAll()
{
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kSmsPopupSearchList));
	if (!pList)
	{
		ASSERT(FALSE);
		return;
	}
	pList->RemoveAll();
	int nCount = root_node_->num_children();
	for (int i = nCount - 1; i >=0;  i--)
	{
		Node* child = root_node_->child(i);
		RemoveNode(child);
	}
	delete root_node_;

	root_node_ = new Node;
	root_node_->data().level_ = -1;
	root_node_->data().child_visible_ = true;
	root_node_->data().has_child_ = true;
	root_node_->data().list_elment_ = NULL;
}



Node* CSmsSearchWnd::AddNode(const SmsSearchItemInfo& item,const NE_MEMBER_DATA* pMembereData, 	GTUserStatusType status,int nCompareData, Node* parent, int nTopPadding)
{
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kSmsPopupSearchList));
    if (NULL == pList)
    {
		ASSERT(FALSE);
		return NULL;
    }
	if (!parent)
		parent = root_node_;

	TCHAR szBuf[MAX_PATH] = {0};

	CListContainerElementUI* pListElement = NULL;
	if( !m_dlgBuilder.GetMarkup()->IsValid() ) {
		pListElement = static_cast<CListContainerElementUI*>(m_dlgBuilder.Create(_T("sms_search_item.xml"), (UINT)0, NULL, &m_PaintManager));
	}
	else {
		pListElement = static_cast<CListContainerElementUI*>(m_dlgBuilder.Create((UINT)0, &m_PaintManager));
	}
	if (pListElement == NULL)
		return NULL;

	//pListElement->SetCompareData(nCompareData);

	Node* node = new Node;

	node->SetComapreData(nCompareData);

	node->data().level_ = parent->data().level_ + 1;
	
	node->data().has_child_ = false;

	node->data().folder_ = false;

	node->data().child_visible_ = (node->data().level_ == 0);
	node->data().child_visible_ = false;

	node->data().text_ = item.nick_name;
	node->data().value = item.id;
	node->data().tel = item.tel;
	node->data().list_elment_ = pListElement;

	if (!parent->data().child_visible_)
		pListElement->SetVisible(false);

	if (parent != root_node_ && !parent->data().list_elment_->IsVisible())
		pListElement->SetVisible(false);

	CDuiRect rcPadding = text_padding_;
	rcPadding.top += nTopPadding;
	for (int i = 0; i < node->data().level_; ++i)
	{
		rcPadding.left += level_text_start_pos_;		
	}
	pListElement->SetPadding(rcPadding);

	CButtonUI* log_button = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(pListElement, kSmsPopupSearchItemLogo));
	if (log_button != NULL)
	{
		//_stprintf_s(szBuf, MAX_PATH - 1, _T("%s"), item.logo);

		//CDuiString strStatusImage = GET_MESSENGER_DLG()->GetMainFrame()->GetImageFromStatus(status,false,!pMembereData->strWorkStatus.empty());
		log_button->SetBkImage(item.logo);
		log_button->SetTag((UINT_PTR)pListElement);
		CString strBuf = _T("");
		strBuf.Format(LoadStringFromResource(IDS_STRING_RECENT_CHAT_TOOLTIP_3), pMembereData->strName.c_str(), GetPresenceTip(status), pMembereData->strEmail.c_str());

		if (ustOFFLINE == status && GET_CONFIG()->EnableFunction(_T("UI_01")) && !pMembereData->strWorkStatus.empty())
		{
			CString strToolTip = pMembereData->strWorkStatus.c_str();
			strToolTip.Replace(_T(":"),_T("\n"));
			log_button->SetToolTip(strToolTip);
		}
		else
		{
			log_button->SetToolTip(strBuf);
		}
		log_button->OnEvent += MakeDelegate(&OnLogoButtonEvent);
	}

	CDuiString html_text;

    _stprintf_s(szBuf, MAX_PATH - 1, _T("%s"), item.nick_name);
	html_text += szBuf;
	

	CLabelUI* nick_name = static_cast<CLabelUI*>(m_PaintManager.FindSubControlByName(pListElement, kSmsPopupSearchItemName));
	if (nick_name != NULL)
	{		
		nick_name->SetShowHtml(true);
		nick_name->SetText(html_text);
	}

	CLabelUI* tel = static_cast<CLabelUI*>(m_PaintManager.FindSubControlByName(pListElement, kSmsPopupSearchItemTel));
	if (tel != NULL)
	{	

		tel->SetShowHtml(true);
		tel->SetText(item.tel);
	}
	CButtonUI* btn_add = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(pListElement, kSmsPopupSearchItemAdd));

	if (btn_add != NULL)
	{
		btn_add->SetTag((UINT_PTR)node);		
	//	btn_add->OnEvent += MakeDelegate(&OnAddButtonEvent);
        if (!m_pSmsSendWnd->FindTelInSMSWnd((CString)item.tel))
        {
			CString strImage = GetAppDUIImgDir() + _T("\\btn_chat_memberadd_nor.png");
			btn_add->SetBkImage(strImage);
			btn_add->SetToolTip(LoadStringFromResource(IDS_STRING_CHAT_TOOLTIP_15));		
			btn_add->SetEnabled(true);
        }
		else
		{
			
			CString strImage = GetAppDUIImgDir() + _T("\\btn_chat_memberadd_off.png");
			btn_add->SetBkImage(strImage);
			btn_add->SetEnabled(false);
		}
		
	}
	pListElement->SetTag((UINT_PTR)node);
	pListElement->SetFixedHeight(30);

	int index = 0;
	int innerIndex = 0;
	int iSumChildCount = 0;
	if (parent->has_children())
	{
		Node* prev = parent->get_last_child();
		index = prev->data().list_elment_->GetIndex() + 1;
		for (int i = 0; i < parent->num_children(); i++)
		{
			Node* pNode = parent->child(i);
			if(pNode->GetCompareData() > nCompareData)
			{
				index = pNode->data().list_elment_->GetIndex();
				break;
			}
			else
			{
				iSumChildCount += pNode->num_children();
			}
		}

		if (parent == root_node_)
		{
			innerIndex = index - iSumChildCount;
		}
		else
		{
			innerIndex = index - parent->data().list_elment_->GetIndex() - 1;
		}

	}
	else 
	{
		if (parent == root_node_)
			index = 0;
		else
		{
			index = parent->data().list_elment_->GetIndex() + 1;
		}
		innerIndex = 0;
	}
	if (!pList->AddAt(pListElement, index))
	{
		delete pListElement;
		delete node;
		node = NULL;
	}

	parent->insert_child(node, innerIndex);
	return node;
}


bool CSmsSearchWnd::RemoveNode(Node* node)
{
	if (!node || node == root_node_) return false;

	int nCount = node->num_children();
	for (int i = nCount - 1; i >=0;  i--)
	{
		Node* child = node->child(i);
		RemoveNode(child);
	}
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kSmsPopupSearchList));

	pList->Remove(node->data().list_elment_);
	node->parent()->remove_child(node);
	delete node;

	return true;
}

Node* CSmsSearchWnd::FindNode(Node* node,CString usrID)
{
	int nCount = node->num_children();
	for (int i = 0; i <=nCount - 1;  i++)
	{
		Node* child = node->child(i);
		if (0 == child->data().value.CompareNoCase(usrID))
		{
			return child;
		}
	}
	return NULL;
}

void CSmsSearchWnd:: UpdateSearchWndMember(const std::vector<ORG_MEMBER_DATA> &memberVector)
{	
	CListUI* pFriendsList = GetFriendsCtrl();
	if (pFriendsList != NULL)
	{
		if (!m_vecfriend.empty())
		{
			m_vecfriend.clear();
		}
	    RemoveAll();

	     SmsSearchItemInfo item;
		list<wstring> listUserIds;
		int nSmsSearchWndHeight = SMS_SEARCH_WINDOW_TOP_PADDING;
		for (size_t i = 0; i < memberVector.size(); i++)
		{
			NE_MEMBER_DATA sMemberInfo = memberVector[i].neMemberData;
			item.id = sMemberInfo.strUserId.c_str();
			listUserIds.push_back(sMemberInfo.strUserId);
			
			item.nick_name = sMemberInfo.strName.c_str();
			item.tel = sMemberInfo.strCellPhone.c_str();
			GTUserStatusType eUserStatus = GET_MESSENGER_DLG()->GetWorkGroupController()->GetMemberStatus(sMemberInfo.strUserId.c_str());


			GT_MY_USER_DATA myUserData;
			g_pMessengerActor->GetMyUserInfo(myUserData);

			if (sMemberInfo.strUserId == myUserData.strUserID)			
			{
                  eUserStatus = myUserData.eUserStatusType;
			}
			

			CString strImage = _T("");
			strImage =  GET_MESSENGER_DLG()->GetMainFrame()->GetImageFromStatus(eUserStatus,false,!sMemberInfo.strWorkStatus.empty());
			item.logo = strImage;
	
			Node* pUserNode = NULL;
			if (i == 0)
			{
				pUserNode = AddNode(item,&sMemberInfo,eUserStatus, NULL, NULL, SMS_SEARCH_WINDOW_TOP_PADDING);
			}
			else
			{
				pUserNode = AddNode(item,&sMemberInfo, eUserStatus,NULL);
			}

			CButtonUI* pBtnAdd = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(pUserNode->data().list_elment_, kSmsPopupSearchItemAdd));
			if(pBtnAdd)
			   pBtnAdd->SetEnabled(true);


			nSmsSearchWndHeight += 28;
		}

		nSmsSearchWndHeight = min(nSmsSearchWndHeight, (SMS_SEARCH_WINDOW_TOP_PADDING + 28)*2);
		nSmsSearchWndHeight = max(nSmsSearchWndHeight, 50);
		SetSearchHeight(nSmsSearchWndHeight, TRUE);
		ShowWindow(true, true);
		SetFocus(GetHWND());

		CLabelUI* pSearchResult = static_cast<CLabelUI*>(m_PaintManager.FindControl(kNosearchResult));
		if (pSearchResult != NULL)
		{
			pSearchResult->SetText(LoadStringFromResource(IDS_STRING_NOSEARCH_RESULT));
			if (memberVector.size() == 0)
			{
				pSearchResult->SetVisible(true); 
			}
		}
		
	}
	vector<wstring> vecUsers;
	std::vector<ORG_MEMBER_DATA>::const_iterator itr = memberVector.begin();
	for(; itr != memberVector.end(); itr++)
		vecUsers.push_back(itr->neMemberData.strUserId);
   g_pMessengerActor->RequestRegiFavoriteToPOI(vecUsers, REGPOIGROUP_SMSSEARCH);
}

/////////////////////////////////////////////////////////
/////   csmsRecentPopup////////////////////////////////
/////////////////////////////////////////////////////////



DUI_BEGIN_MESSAGE_MAP(CSmsRecentContactWnd, WindowImplBase, FALSE)
DUI_ON_MSGTYPE(DUI_MSGTYPE_WINDOWINIT, _OnNotifyPrepare)
DUI_ON_MSGTYPE(DUI_MSGTYPE_ITEMCLICK, _OnNotifyItemClick)
DUI_ON_MSGTYPE(WM_SYSKEYDOWN, _OnMsgSysKeyDown)
DUI_END_MESSAGE_MAP()

DUI_BEGIN_CUSTOM_MSG_MAP(CSmsRecentContactWnd)  
ON_CUSTOM_MSG(MSG_ACTIVE_PRARENT, _OnMsgActiveParent)
ON_CUSTOM_MSG(MSG_INACTIVE_HIDE, _OnMsgInactiveHide)
DUI_END_CUSTOM_MSG_MAP()

CSmsRecentContactWnd::CSmsRecentContactWnd(CSMSSendWnd *pParent):text_padding_(1,1,1,1){

	OutputDebugString(_T("CSmsRecentContactWnd::CSmsRecentContactWnd\n"));
	m_pSmsSendWnd = pParent;
	m_nWndHeight = 1;
	root_node_ = new Node;
	root_node_->data().level_ = -1;
	root_node_->data().child_visible_ = true;
	root_node_->data().has_child_ = true;
	root_node_->data().list_elment_ = NULL;

}

CSmsRecentContactWnd::~CSmsRecentContactWnd(){
	OutputDebugString(_T("~CSmsRecentContactWnd::CSmsRecentContactWnd\n"));

	if (root_node_)
		delete root_node_;

	root_node_ = NULL;
}

LPCTSTR CSmsRecentContactWnd::GetWindowClassName() const{
  return _T("SmsRecentContactWnd");
}

void CSmsRecentContactWnd::InitWindow(){

	MoveWindow(GetHWND(), m_rcClient.left, m_rcClient.top, m_rcClient.Width(), m_rcClient.Height(), TRUE);
}

void CSmsRecentContactWnd::SetRectInParent(CRect rc){
	m_rcClient = rc;
	MoveWindow(GetHWND(), m_rcClient.left, m_rcClient.top, m_rcClient.Width(), m_rcClient.Height(), TRUE);
}

int  CSmsRecentContactWnd::GetChatSearchHeight(){
  return m_nWndHeight;
}

CListUI* CSmsRecentContactWnd::GetFriendsCtrl(){
	CListUI* pFriendsList = static_cast<CListUI*>(m_PaintManager.FindControl(kSmsPopupSearchList));
	return pFriendsList;
}


CDuiString CSmsRecentContactWnd::GetSkinFile(){
   return _T("SmsRecentWnd.xml");
}
 CDuiString CSmsRecentContactWnd::GetSkinFolder(){
    return _T("skin\\nTalkRes");
 }

 void CSmsRecentContactWnd::OnFinalMessage(HWND hWnd){
	 OutputDebugString(_T("CSmsRecentContactWnd::OnFinalMessage\n"));

	 CListUI* pFriendsList = GetFriendsCtrl();
	 if (pFriendsList != NULL)
	 {
		 if (pFriendsList->GetCount() > 0)
		 {
			 pFriendsList->RemoveAll();
		 }
	 }
	 WindowImplBase::OnFinalMessage(hWnd);
	 if (m_pSmsSendWnd != NULL)
	 {
		 ::PostMessage(m_pSmsSendWnd->GetHWND(), MSG_CLOSE_RECENT_CONTACT, 0, 0);
	 }
	 delete this;
 }
 LRESULT CSmsRecentContactWnd::OnKillFocus(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled){
	 CPoint pt(0, 0);
	 GetCursorPos(&pt);
	 CRect rcClient(0, 0, 0, 0);
	 GetWindowRect(m_hWnd, rcClient);
	 CRect rcSearchBtn(rcClient.left + 3, rcClient.bottom, rcClient.left + 25, rcClient.bottom + 30);
	 CRect rcProfile(0, 0, 0, 0);
	
	 if (m_pSmsSendWnd != NULL && !rcClient.PtInRect(pt) && !rcSearchBtn.PtInRect(pt) )
	 {
		 m_pSmsSendWnd->CloseSmsRecentContactWnd(TRUE);
	 }
	 return 0;
 }

 void CSmsRecentContactWnd::RemoveAll(){

	 CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kSmsPopupSearchList));
	 if (!pList)
	 {
		 ASSERT(FALSE);
		 return;
	 }
	 pList->RemoveAll();
	 int nCount = root_node_->num_children();
	 for (int i = nCount - 1; i >=0;  i--)
	 {
		 Node* child = root_node_->child(i);
		 RemoveNode(child);
	 }
	 delete root_node_;

	 root_node_ = new Node;
	 root_node_->data().level_ = -1;
	 root_node_->data().child_visible_ = true;
	 root_node_->data().has_child_ = true;
	 root_node_->data().list_elment_ = NULL;
 }


Node* CSmsRecentContactWnd::AddNode(const SmsSearchItemInfo& item, int nCompareData, Node* parent, int nTopPadding ){
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kSmsPopupSearchList));
	if (NULL == pList)
	{
		ASSERT(FALSE);
		return NULL;
	}
	if (!parent)
		parent = root_node_;

	TCHAR szBuf[MAX_PATH] = {0};

	CListContainerElementUI* pListElement = NULL;
	if( !m_dlgBuilder.GetMarkup()->IsValid() ) {
		pListElement = static_cast<CListContainerElementUI*>(m_dlgBuilder.Create(_T("sms_recentmenu_item.xml"), (UINT)0, NULL, &m_PaintManager));
	}
	else {
		pListElement = static_cast<CListContainerElementUI*>(m_dlgBuilder.Create((UINT)0, &m_PaintManager));
	}
	if (pListElement == NULL)
		return NULL;

	Node* node = new Node;

	node->SetComapreData(nCompareData);

	node->data().level_ = parent->data().level_ + 1;

	node->data().has_child_ = false;

	node->data().folder_ = false;

	node->data().child_visible_ = (node->data().level_ == 0);
	node->data().child_visible_ = false;

	node->data().text_ = item.nick_name;
	node->data().value = item.id;
	node->data().tel = item.tel;
	node->data().list_elment_ = pListElement;

	if (!parent->data().child_visible_)
		pListElement->SetVisible(false);

	if (parent != root_node_ && !parent->data().list_elment_->IsVisible())
		pListElement->SetVisible(false);

	CDuiRect rcPadding = text_padding_;
	rcPadding.top += nTopPadding;

	pListElement->SetPadding(rcPadding);	

	CDuiString html_text;

	_stprintf_s(szBuf, MAX_PATH - 1, _T("%s"), item.nick_name);
	html_text += szBuf;
	CLabelUI* nick_name = static_cast<CLabelUI*>(m_PaintManager.FindSubControlByName(pListElement, kSmsPopupRecentItemName));
	if (nick_name != NULL)
	{		
		nick_name->SetShowHtml(true);
		nick_name->SetText(html_text);
	}
	CLabelUI* tel = static_cast<CLabelUI*>(m_PaintManager.FindSubControlByName(pListElement, kSmsPopupRecentItemTel));
	if (tel != NULL)
	{	
		tel->SetShowHtml(true);
		tel->SetText(item.tel);
	}
	pListElement->SetTag((UINT_PTR)node);
    pListElement->SetFixedHeight(28);
	int index = 0;
	int innerIndex = 0;
	int iSumChildCount = 0;
	if (parent->has_children())
	{
		Node* prev = parent->get_last_child();
		index = prev->data().list_elment_->GetIndex() + 1;
		for (int i = 0; i < parent->num_children(); i++)
		{
			Node* pNode = parent->child(i);
			if(pNode->GetCompareData() > nCompareData)
			{
				index = pNode->data().list_elment_->GetIndex();
				break;
			}
			else
			{
				iSumChildCount += pNode->num_children();
			}
		}

		if (parent == root_node_)
		{
			innerIndex = index - iSumChildCount;
		}
		else
		{
			innerIndex = index - parent->data().list_elment_->GetIndex() - 1;
		}

	}
	else 
	{
		if (parent == root_node_)
			index = 0;
		else
		{
			index = parent->data().list_elment_->GetIndex() + 1;
		}
		innerIndex = 0;
	}
	if (!pList->AddAt(pListElement, index))
	{
		delete pListElement;
		delete node;
		node = NULL;
	}

	parent->insert_child(node, innerIndex);
	return node;
}
bool CSmsRecentContactWnd::RemoveNode(Node* node){

	if (!node || node == root_node_) return false;


	int nCount = node->num_children();
	for (int i = nCount - 1; i >=0;  i--)
	{
		Node* child = node->child(i);
		RemoveNode(child);
	}
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kSmsPopupSearchList));

	pList->Remove(node->data().list_elment_);
	node->parent()->remove_child(node);
	delete node;

	return true;
}
void CSmsRecentContactWnd::SetHeight(int nHeight, BOOL bResize){
	m_nWndHeight = nHeight;
	if (bResize)
	{
		CRect rcSearch = GetRectInParent();		
		rcSearch.bottom = rcSearch.top + m_nWndHeight;
		SetRectInParent(rcSearch);
	}
}
int CSmsRecentContactWnd::GetHeight(){
   return m_nWndHeight;
}
void CSmsRecentContactWnd::LoadRecentContact(){
	CListUI* pFriendsList = GetFriendsCtrl();
	if (pFriendsList != NULL)
	{		
		RemoveAll();
		SmsSearchItemInfo item;
		list<wstring> listUserIds;
		int menuHeight = 0;
		
		CSMSModel* pModel = m_pSmsSendWnd->GetSMSController()->GetSMSModel();
		
		for (size_t i = 0; i < m_pSmsSendWnd->GetSMSController()->GetRecentReceiverCount(); i++)
		{

			CSMSModel::SMSReceiverInfo info = pModel->m_recentReceiverVector[i];
			item.id = info.strID;
			if (info.strName.IsEmpty())
			{
                 item.nick_name = item.id;
			}
			else{
			  item.nick_name = info.strName;
			}
			item.tel = info.strCellPhone;	

			Node* pUserNode = NULL;
			
			
		    pUserNode = AddNode(item, NULL);		


			menuHeight += 28;
		}
        menuHeight += 10;
		menuHeight = min(menuHeight, 292);
		SetHeight(menuHeight, TRUE);
		ShowWindow(true, true);
		SetFocus(GetHWND());

	}
}

void CSmsRecentContactWnd::_OnNotifyPrepare(TNotifyUI& msg){

	 LoadRecentContact();

}
LRESULT CSmsRecentContactWnd::OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	return HTCLIENT;
}
void CSmsRecentContactWnd::_OnNotifyItemClick(TNotifyUI& msg){
	CListUI* pFriendsList = static_cast<CListUI*>(m_PaintManager.FindControl(kSmsPopupSearchList));
	if ((pFriendsList != NULL) &&  pFriendsList->GetItemIndex(msg.pSender) != -1)
	{
		if (_tcsicmp(msg.pSender->GetClass(), _T("ListContainerElementUI")) == 0)
		{
			Node* node = (Node*)msg.pSender->GetTag();
			//::PostMessage(m_pSmsSendWnd->GetHWND(), WM_ADD_USER_SMS, (WPARAM)node, 0);
			//fix:ntalkcl-1274
			m_pSmsSendWnd->InitializeMsgPopOnce();
			m_pSmsSendWnd->OnAddUserToSMS(node);

		}
	}
	Close();
}


LRESULT CSmsRecentContactWnd::OnKeyDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled){

	if ((TCHAR)wParam == VK_ESCAPE)
	{
		if (m_pSmsSendWnd != NULL)
		{
			m_pSmsSendWnd->CloseSmsRecentContactWnd( TRUE);
			
		}
		bHandled = TRUE;
	}
	else
	{
		bHandled = FALSE;
	}
	return 0; 
	
}
void CSmsRecentContactWnd::_OnMsgSysKeyDown(TNotifyUI& msg){
	if (GetKeyState(VK_MENU) < 0 && VK_F4 == msg.wParam)
	{
		if (m_pSmsSendWnd != NULL)
		{
			m_pSmsSendWnd->CloseSmsRecentContactWnd( TRUE);
			// bHandled = TRUE;
		}
	}
}

LRESULT CSmsRecentContactWnd::_OnMsgActiveParent(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled){
   return 0;
}
LRESULT CSmsRecentContactWnd::_OnMsgInactiveHide(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled){
	return 0;

}






